// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from qml_group.cpp.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#include "BackgroundPropertyGroup.h"

#include <QQmlEngine>

#include "QuickStyle.h"

using namespace Union::Properties;
using namespace Qt::StringLiterals;

BackgroundPropertyGroup::BackgroundPropertyGroup(QuickStyle *style)
    : QObject()
    , m_style(style)
{
    m_image = std::make_unique<ImagePropertyGroup>(m_style);
    m_border = std::make_unique<BorderPropertyGroup>(m_style);
    m_corners = std::make_unique<CornersPropertyGroup>(m_style);
    m_shadow = std::make_unique<ShadowPropertyGroup>(m_style);
}

void BackgroundPropertyGroup::update(const BackgroundProperty &newState)
{
    m_state = newState;
    Q_EMIT colorChanged();
    m_image->update(newState.image().value_or(ImageProperty{}));
    m_border->update(newState.border().value_or(BorderProperty{}));
    m_corners->update(newState.corners().value_or(CornersProperty{}));
    m_shadow->update(newState.shadow().value_or(ShadowProperty{}));

    Q_EMIT updated();
}

QJSValue BackgroundPropertyGroup::color() const
{
    auto value = m_state.color();
    if (value) {
        return m_style->engine()->toScriptValue(value.value());
    }

    return QJSValue(QJSValue::UndefinedValue);
}

ImagePropertyGroup *BackgroundPropertyGroup::image() const
{
    return m_image.get();
}

BorderPropertyGroup *BackgroundPropertyGroup::border() const
{
    return m_border.get();
}

CornersPropertyGroup *BackgroundPropertyGroup::corners() const
{
    return m_corners.get();
}

ShadowPropertyGroup *BackgroundPropertyGroup::shadow() const
{
    return m_shadow.get();
}

#include "moc_BackgroundPropertyGroup.cpp"