// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from qml_group.cpp.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#include "SizePropertyGroup.h"

#include <QQmlEngine>

#include "QuickStyle.h"

using namespace Union::Properties;
using namespace Qt::StringLiterals;

SizePropertyGroup::SizePropertyGroup(QuickStyle *style)
    : QObject()
    , m_style(style)
{
}

void SizePropertyGroup::update(const SizeProperty &newState)
{
    m_state = newState;
    Q_EMIT leftChanged();
    Q_EMIT rightChanged();
    Q_EMIT topChanged();
    Q_EMIT bottomChanged();

    Q_EMIT updated();
}

QJSValue SizePropertyGroup::left() const
{
    auto value = m_state.left();
    if (value) {
        return m_style->engine()->toScriptValue(value.value());
    }

    return QJSValue(QJSValue::UndefinedValue);
}

QJSValue SizePropertyGroup::right() const
{
    auto value = m_state.right();
    if (value) {
        return m_style->engine()->toScriptValue(value.value());
    }

    return QJSValue(QJSValue::UndefinedValue);
}

QJSValue SizePropertyGroup::top() const
{
    auto value = m_state.top();
    if (value) {
        return m_style->engine()->toScriptValue(value.value());
    }

    return QJSValue(QJSValue::UndefinedValue);
}

QJSValue SizePropertyGroup::bottom() const
{
    auto value = m_state.bottom();
    if (value) {
        return m_style->engine()->toScriptValue(value.value());
    }

    return QJSValue(QJSValue::UndefinedValue);
}

#include "moc_SizePropertyGroup.cpp"