// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from qml_group.cpp.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#include "TextPropertyGroup.h"

#include <QQmlEngine>

#include "QuickStyle.h"

using namespace Union::Properties;
using namespace Qt::StringLiterals;

TextPropertyGroup::TextPropertyGroup(QuickStyle *style)
    : QObject()
    , m_style(style)
{
    m_alignment = std::make_unique<AlignmentPropertyGroup>(m_style);
}

void TextPropertyGroup::update(const TextProperty &newState)
{
    m_state = newState;
    m_alignment->update(newState.alignment().value_or(AlignmentProperty{}));
    Q_EMIT fontChanged();

    Q_EMIT updated();
}

AlignmentPropertyGroup *TextPropertyGroup::alignment() const
{
    return m_alignment.get();
}

QJSValue TextPropertyGroup::font() const
{
    auto value = m_state.font();
    if (value) {
        return m_style->engine()->toScriptValue(value.value());
    }

    return QJSValue(QJSValue::UndefinedValue);
}

#include "moc_TextPropertyGroup.cpp"