// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from property.h.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#pragma once

// clang-format off

#include <QDebug>


#include "../PropertiesTypes.h"

#include "union_export.h"

// clang-format on

namespace Union
{
namespace Properties
{

class AlignmentPropertyPrivate;

class UNION_EXPORT AlignmentProperty
{
public:
    AlignmentProperty();
    AlignmentProperty(const AlignmentProperty &other);
    AlignmentProperty(AlignmentProperty &&other);
    ~AlignmentProperty();

    AlignmentProperty &operator=(const AlignmentProperty &other);
    AlignmentProperty &operator=(AlignmentProperty &&other);

    std::optional<Union::Properties::AlignmentContainer> container() const;
    void setContainer(const std::optional<Union::Properties::AlignmentContainer> &newValue);

    std::optional<Union::Properties::Alignment> horizontal() const;
    void setHorizontal(const std::optional<Union::Properties::Alignment> &newValue);

    std::optional<Union::Properties::Alignment> vertical() const;
    void setVertical(const std::optional<Union::Properties::Alignment> &newValue);

    std::optional<int> order() const;
    void setOrder(const std::optional<int> &newValue);

    /**
     * Check if this property has any value set.
     *
     * Note that for any sub property that this property has, it also checks if
     * that sub-property has any value.
     */
    bool hasAnyValue() const;

    /**
     * Copy values from source to destination if destination does not have a value.
     *
     * This will recursively copy sub-values.
     *
     * \param source The source property to copy from.
     * \param destination The destination property to copy to.
     */
    static void resolveProperties(const AlignmentProperty &source, AlignmentProperty &destination);

    /**
     * Create and return an empty AlignmentProperty instance.
     *
     * This will create an empty AlignmentProperty instance, which is defined as
     * an instance with all of its values default-constructed. Note that this is
     * different from a default-constructed instance which will have all its
     * values unset.
     */
    static AlignmentProperty empty();

private:
    std::unique_ptr<AlignmentPropertyPrivate> d;
};

UNION_EXPORT bool operator==(const AlignmentProperty &left, const AlignmentProperty &right);
UNION_EXPORT inline bool operator!=(const AlignmentProperty &left, const AlignmentProperty &right)
{
    return !(left == right);
}

}
}

UNION_EXPORT QDebug operator<<(QDebug debug, const Union::Properties::AlignmentProperty &type);