// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from property.h.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#pragma once

// clang-format off

#include <QDebug>


#include "LineProperty.h"

#include "union_export.h"

// clang-format on

namespace Union
{
namespace Properties
{

class BorderPropertyPrivate;

class UNION_EXPORT BorderProperty
{
public:
    BorderProperty();
    BorderProperty(const BorderProperty &other);
    BorderProperty(BorderProperty &&other);
    ~BorderProperty();

    BorderProperty &operator=(const BorderProperty &other);
    BorderProperty &operator=(BorderProperty &&other);

    std::optional<LineProperty> left() const;
    void setLeft(const std::optional<LineProperty> &newValue);

    std::optional<LineProperty> right() const;
    void setRight(const std::optional<LineProperty> &newValue);

    std::optional<LineProperty> top() const;
    void setTop(const std::optional<LineProperty> &newValue);

    std::optional<LineProperty> bottom() const;
    void setBottom(const std::optional<LineProperty> &newValue);

    /**
     * Check if this property has any value set.
     *
     * Note that for any sub property that this property has, it also checks if
     * that sub-property has any value.
     */
    bool hasAnyValue() const;

    /**
     * Copy values from source to destination if destination does not have a value.
     *
     * This will recursively copy sub-values.
     *
     * \param source The source property to copy from.
     * \param destination The destination property to copy to.
     */
    static void resolveProperties(const BorderProperty &source, BorderProperty &destination);

    /**
     * Create and return an empty BorderProperty instance.
     *
     * This will create an empty BorderProperty instance, which is defined as
     * an instance with all of its values default-constructed. Note that this is
     * different from a default-constructed instance which will have all its
     * values unset.
     */
    static BorderProperty empty();

private:
    std::unique_ptr<BorderPropertyPrivate> d;
};

UNION_EXPORT bool operator==(const BorderProperty &left, const BorderProperty &right);
UNION_EXPORT inline bool operator!=(const BorderProperty &left, const BorderProperty &right)
{
    return !(left == right);
}

}
}

UNION_EXPORT QDebug operator<<(QDebug debug, const Union::Properties::BorderProperty &type);