// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from property.h.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#pragma once

// clang-format off

#include <QDebug>

#include <QColor>

#include "ImageProperty.h"

#include "union_export.h"

// clang-format on

namespace Union
{
namespace Properties
{

class CornerPropertyPrivate;

class UNION_EXPORT CornerProperty
{
public:
    CornerProperty();
    CornerProperty(const CornerProperty &other);
    CornerProperty(CornerProperty &&other);
    ~CornerProperty();

    CornerProperty &operator=(const CornerProperty &other);
    CornerProperty &operator=(CornerProperty &&other);

    std::optional<qreal> radius() const;
    void setRadius(const std::optional<qreal> &newValue);

    std::optional<qreal> width() const;
    void setWidth(const std::optional<qreal> &newValue);

    std::optional<qreal> height() const;
    void setHeight(const std::optional<qreal> &newValue);

    std::optional<QColor> color() const;
    void setColor(const std::optional<QColor> &newValue);

    std::optional<ImageProperty> image() const;
    void setImage(const std::optional<ImageProperty> &newValue);

    /**
     * Check if this property has any value set.
     *
     * Note that for any sub property that this property has, it also checks if
     * that sub-property has any value.
     */
    bool hasAnyValue() const;

    /**
     * Copy values from source to destination if destination does not have a value.
     *
     * This will recursively copy sub-values.
     *
     * \param source The source property to copy from.
     * \param destination The destination property to copy to.
     */
    static void resolveProperties(const CornerProperty &source, CornerProperty &destination);

    /**
     * Create and return an empty CornerProperty instance.
     *
     * This will create an empty CornerProperty instance, which is defined as
     * an instance with all of its values default-constructed. Note that this is
     * different from a default-constructed instance which will have all its
     * values unset.
     */
    static CornerProperty empty();

private:
    std::unique_ptr<CornerPropertyPrivate> d;
};

UNION_EXPORT bool operator==(const CornerProperty &left, const CornerProperty &right);
UNION_EXPORT inline bool operator!=(const CornerProperty &left, const CornerProperty &right)
{
    return !(left == right);
}

}
}

UNION_EXPORT QDebug operator<<(QDebug debug, const Union::Properties::CornerProperty &type);