// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from property.h.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#pragma once

// clang-format off

#include <QDebug>

#include <QString>
#include <QUrl>

#include "AlignmentProperty.h"

#include "union_export.h"

// clang-format on

namespace Union
{
namespace Properties
{

class IconPropertyPrivate;

class UNION_EXPORT IconProperty
{
public:
    IconProperty();
    IconProperty(const IconProperty &other);
    IconProperty(IconProperty &&other);
    ~IconProperty();

    IconProperty &operator=(const IconProperty &other);
    IconProperty &operator=(IconProperty &&other);

    std::optional<AlignmentProperty> alignment() const;
    void setAlignment(const std::optional<AlignmentProperty> &newValue);

    std::optional<qreal> width() const;
    void setWidth(const std::optional<qreal> &newValue);

    std::optional<qreal> height() const;
    void setHeight(const std::optional<qreal> &newValue);

    std::optional<QString> name() const;
    void setName(const std::optional<QString> &newValue);

    std::optional<QUrl> source() const;
    void setSource(const std::optional<QUrl> &newValue);

    /**
     * Check if this property has any value set.
     *
     * Note that for any sub property that this property has, it also checks if
     * that sub-property has any value.
     */
    bool hasAnyValue() const;

    /**
     * Copy values from source to destination if destination does not have a value.
     *
     * This will recursively copy sub-values.
     *
     * \param source The source property to copy from.
     * \param destination The destination property to copy to.
     */
    static void resolveProperties(const IconProperty &source, IconProperty &destination);

    /**
     * Create and return an empty IconProperty instance.
     *
     * This will create an empty IconProperty instance, which is defined as
     * an instance with all of its values default-constructed. Note that this is
     * different from a default-constructed instance which will have all its
     * values unset.
     */
    static IconProperty empty();

private:
    std::unique_ptr<IconPropertyPrivate> d;
};

UNION_EXPORT bool operator==(const IconProperty &left, const IconProperty &right);
UNION_EXPORT inline bool operator!=(const IconProperty &left, const IconProperty &right)
{
    return !(left == right);
}

}
}

UNION_EXPORT QDebug operator<<(QDebug debug, const Union::Properties::IconProperty &type);