// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from property.h.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#pragma once

// clang-format off

#include <QDebug>


#include "AlignmentProperty.h"
#include "SizeProperty.h"

#include "union_export.h"

// clang-format on

namespace Union
{
namespace Properties
{

class LayoutPropertyPrivate;

class UNION_EXPORT LayoutProperty
{
public:
    LayoutProperty();
    LayoutProperty(const LayoutProperty &other);
    LayoutProperty(LayoutProperty &&other);
    ~LayoutProperty();

    LayoutProperty &operator=(const LayoutProperty &other);
    LayoutProperty &operator=(LayoutProperty &&other);

    std::optional<AlignmentProperty> alignment() const;
    void setAlignment(const std::optional<AlignmentProperty> &newValue);

    std::optional<qreal> width() const;
    void setWidth(const std::optional<qreal> &newValue);

    std::optional<qreal> height() const;
    void setHeight(const std::optional<qreal> &newValue);

    std::optional<qreal> spacing() const;
    void setSpacing(const std::optional<qreal> &newValue);

    std::optional<SizeProperty> padding() const;
    void setPadding(const std::optional<SizeProperty> &newValue);

    std::optional<SizeProperty> inset() const;
    void setInset(const std::optional<SizeProperty> &newValue);

    std::optional<SizeProperty> margins() const;
    void setMargins(const std::optional<SizeProperty> &newValue);

    /**
     * Check if this property has any value set.
     *
     * Note that for any sub property that this property has, it also checks if
     * that sub-property has any value.
     */
    bool hasAnyValue() const;

    /**
     * Copy values from source to destination if destination does not have a value.
     *
     * This will recursively copy sub-values.
     *
     * \param source The source property to copy from.
     * \param destination The destination property to copy to.
     */
    static void resolveProperties(const LayoutProperty &source, LayoutProperty &destination);

    /**
     * Create and return an empty LayoutProperty instance.
     *
     * This will create an empty LayoutProperty instance, which is defined as
     * an instance with all of its values default-constructed. Note that this is
     * different from a default-constructed instance which will have all its
     * values unset.
     */
    static LayoutProperty empty();

private:
    std::unique_ptr<LayoutPropertyPrivate> d;
};

UNION_EXPORT bool operator==(const LayoutProperty &left, const LayoutProperty &right);
UNION_EXPORT inline bool operator!=(const LayoutProperty &left, const LayoutProperty &right)
{
    return !(left == right);
}

}
}

UNION_EXPORT QDebug operator<<(QDebug debug, const Union::Properties::LayoutProperty &type);