// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from property.h.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#pragma once

// clang-format off

#include <QDebug>

#include <QMarginsF>


#include "union_export.h"

// clang-format on

namespace Union
{
namespace Properties
{

class SizePropertyPrivate;

class UNION_EXPORT SizeProperty
{
public:
    SizeProperty();
    SizeProperty(const SizeProperty &other);
    SizeProperty(SizeProperty &&other);
    ~SizeProperty();

    SizeProperty &operator=(const SizeProperty &other);
    SizeProperty &operator=(SizeProperty &&other);

    std::optional<qreal> left() const;
    void setLeft(const std::optional<qreal> &newValue);

    std::optional<qreal> right() const;
    void setRight(const std::optional<qreal> &newValue);

    std::optional<qreal> top() const;
    void setTop(const std::optional<qreal> &newValue);

    std::optional<qreal> bottom() const;
    void setBottom(const std::optional<qreal> &newValue);

    /**
     * Check if this property has any value set.
     *
     * Note that for any sub property that this property has, it also checks if
     * that sub-property has any value.
     */
    bool hasAnyValue() const;

    /**
     * Copy values from source to destination if destination does not have a value.
     *
     * This will recursively copy sub-values.
     *
     * \param source The source property to copy from.
     * \param destination The destination property to copy to.
     */
    static void resolveProperties(const SizeProperty &source, SizeProperty &destination);

    /**
     * Create and return an empty SizeProperty instance.
     *
     * This will create an empty SizeProperty instance, which is defined as
     * an instance with all of its values default-constructed. Note that this is
     * different from a default-constructed instance which will have all its
     * values unset.
     */
    static SizeProperty empty();

    /*!
       Convert a Size property to QMarginsF.

       If any values are not set, they will use 0.0.
     */
    QMarginsF toMargins() const;

private:
    std::unique_ptr<SizePropertyPrivate> d;
};

UNION_EXPORT bool operator==(const SizeProperty &left, const SizeProperty &right);
UNION_EXPORT inline bool operator!=(const SizeProperty &left, const SizeProperty &right)
{
    return !(left == right);
}

}
}

UNION_EXPORT QDebug operator<<(QDebug debug, const Union::Properties::SizeProperty &type);