// SPDX-License-Identifier: LGPL-2.1-only OR LGPL-3.0-only OR LicenseRef-KDE-Accepted-LGPL
// SPDX-FileCopyrightText: 2024 Arjen Hiemstra <ahiemstra@heimr.nl>
//
// This file is automatically generated from property.h.j2.
// To regenerate, run `tools/propertygenerator/generate_properties.py`.

#pragma once

// clang-format off

#include <QDebug>

#include <QFont>

#include "AlignmentProperty.h"

#include "union_export.h"

// clang-format on

namespace Union
{
namespace Properties
{

class TextPropertyPrivate;

class UNION_EXPORT TextProperty
{
public:
    TextProperty();
    TextProperty(const TextProperty &other);
    TextProperty(TextProperty &&other);
    ~TextProperty();

    TextProperty &operator=(const TextProperty &other);
    TextProperty &operator=(TextProperty &&other);

    std::optional<AlignmentProperty> alignment() const;
    void setAlignment(const std::optional<AlignmentProperty> &newValue);

    std::optional<QFont> font() const;
    void setFont(const std::optional<QFont> &newValue);

    /**
     * Check if this property has any value set.
     *
     * Note that for any sub property that this property has, it also checks if
     * that sub-property has any value.
     */
    bool hasAnyValue() const;

    /**
     * Copy values from source to destination if destination does not have a value.
     *
     * This will recursively copy sub-values.
     *
     * \param source The source property to copy from.
     * \param destination The destination property to copy to.
     */
    static void resolveProperties(const TextProperty &source, TextProperty &destination);

    /**
     * Create and return an empty TextProperty instance.
     *
     * This will create an empty TextProperty instance, which is defined as
     * an instance with all of its values default-constructed. Note that this is
     * different from a default-constructed instance which will have all its
     * values unset.
     */
    static TextProperty empty();

private:
    std::unique_ptr<TextPropertyPrivate> d;
};

UNION_EXPORT bool operator==(const TextProperty &left, const TextProperty &right);
UNION_EXPORT inline bool operator!=(const TextProperty &left, const TextProperty &right)
{
    return !(left == right);
}

}
}

UNION_EXPORT QDebug operator<<(QDebug debug, const Union::Properties::TextProperty &type);